﻿using RobotSwarms.HICCUP;
using Microsoft.EntityFrameworkCore;
using System.ComponentModel.DataAnnotations.Schema;

namespace RobotSwarms.Domainprimitives
{
    public class Ore
    {
        /// <summary>
        /// 
        /// </summary>
        public int Amount { get; private set; }

        /// <summary>
        /// 
        /// </summary>
        [NotMapped]
        public bool IsZero { get => Amount == 0; }


        #region Constructor

        private Ore(int oreCount)
        {
            this.Amount = oreCount;
        }

        private Ore() : this(0)
        {
        }

        #endregion

        #region Methods

        /// <summary>
        /// Creates new Ore
        /// </summary>
        /// <param name="amount"></param>
        /// <returns></returns>
        /// <exception cref="ExplorationRobotControlException"></exception>
        public static Ore FromAmount(int amount)
        {
            if (amount < 0) throw new ExplorationRobotControlException("amount needs to be a positive value");
            return new Ore(amount);
        }

        /// <summary>
        /// Creates a new instance of Ore using this and another instance to merge from
        /// </summary>
        /// <param name="toObj"></param>
        /// <returns></returns>
        /// <exception cref="ExplorationRobotControlException"></exception>
        public Ore AddTo(Ore toObj)
        {
            if (toObj == null || toObj.Amount <= 0) throw new ExplorationRobotControlException("Provided argument cannot be null or negative");
            return new Ore(toObj.Amount + this.Amount);
        }

        /// <summary>
        /// Creates a new instance of Ore using this and another instance to subtract from
        /// </summary>
        /// <param name="fromObj"></param>
        /// <returns></returns>
        /// <exception cref="ExplorationRobotControlException"></exception>
        public Ore SubtractFrom(Ore fromObj)
        {
            if (fromObj == null || fromObj.Amount <= 0) throw new ExplorationRobotControlException("Provided argument cannot be null or negative");
            int newCount = fromObj.Amount - this.Amount;
            if (newCount < 0) newCount = 0;
            return new Ore(newCount);
        }

        
        public bool IsGreaterThan(Ore theOther)
        {
            if (theOther == null || theOther.Amount < 0) throw new ExplorationRobotControlException("Provided argument cannot be null or negative");
            return this.Amount > theOther.Amount;
        }

        
        public bool IsGreaterEqualThan(Ore theOther)
        {
            if (theOther == null || theOther.Amount < 0) throw new ExplorationRobotControlException("Provided argument cannot be null or negative");
            return this.Amount >= theOther.Amount;
        }
        #endregion

        #region Autogenerated

        public override bool Equals(object? obj)
        {
            return obj is Ore ore &&
                   Amount == ore.Amount;
        }

        public override int GetHashCode()
        {
            return HashCode.Combine(Amount);
        }
        #endregion
    }
}
